package com.brilliance.isc.funds.fxtlop.register.settle;

import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component("fxtlop.settleRegister")
public class FxtlopSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;


    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();
        //this.getSetmod().setDocAmt ( this.getFxdgrp().getCbs().getMax().getCur(), this.getFxdgrp().getCbs().getMax().getAmt(), "Disable" );
        //this.getSetmod().setOpnAmt ( this.getFxdgrp().getCbs().getMax().getAmt() );
        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"TRN" );
        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"SET" );
        //平盘登记交易不产生分录
        //补记外币结转账务
        //###############################
        //!买入
        //!
        //!1、结转：从代客即期结售汇科目（外币）结转到结售汇平盘科目：
        //!借：281110结售汇对外平盘   （外币）
        //!贷：281106代客即期结售汇  （外币）
        //!------------------------------
        //!卖出
        //!
        //!1、结转：从代客即期结售汇科目（外币）结转到结售汇平盘科目：
        //!借：281106代客即期结售汇   （外币）
        //!贷：281110结售汇对外平盘    （外币）
        //###############################
        String act1 = null;
        String ddtKey = null;
        String act4 = null;
        String cbtKey = null;
        if( ! MdaUtils.isEmpty(rec.getFxtyp()) )
        {
            //买入登记
            if( MdaUtils.compareTo(Strings.mid(rec.getFxtyp(),2,1),"B") == 0 )
            {
                //D 281110
                act1 = glemodService.getAvailAcc ( "FX-SLQ", setmodVo.getDoccur(), "", setmodVo.getSetamt() );
                ddtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt(), "", "FXD", "C", act1, "" );
                //C:281106
                act4 = glemodService.getAvailAcc ( "FX-UTL", setmodVo.getDoccur(), "",  setmodVo.getSetamt() );
                cbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "SET", "FXC", "F", act4, "SET" );
            }
            else
            {
                //卖出登记
                //D:281106
                act4 = glemodService.getAvailAcc ( "FX-UTL", setmodVo.getDoccur(), "", setmodVo.getSetamt() );
                ddtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt(), "SET", "FXD", "F", act4, "SET" );
                //C 281110
                act1 = glemodService.getAvailAcc ( "FX-SLQ", setmodVo.getDoccur(), "", setmodVo.getSetamt() );
                cbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "OWN", setmodVo.getDoccur(), setmodVo.getSetamt().negate(), "", "FXC", "C", act1, "" );
            }
        }
    }

}
