package com.brilliance.isc.funds.fxtssb.register.diasav;

import com.brilliance.isc.common.register.diasav.IDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.DftcreDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.LiaallDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.LiaallDiasavZZZRegister;
import com.brilliance.isc.common.register.diasav.common.TrtcreDiasavRegister;
import com.brilliance.isc.common.trndia.service.TrndiaService;
import com.brilliance.isc.common.trndia.vo.TrndiaVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @program: isc-funds
 * @ClassName: FxtssbDiasavRegister
 * @description: 即期结汇 Fxtssb 备忘录注册
 * @author: huangshunlin
 * @create: 2024-10-08 15:39
 */
@Component("fxtssb.diasavRegister")
public class FxtssbDiasavRegister implements IDiasavRegister {

    @Autowired
    private TrndiaService trndiaService;
    @Autowired
    private LiaallDiasavRegister liaallDiasavRegister;
    @Autowired
    private LiaallDiasavZZZRegister liaallDiasavZZZRegister;
    @Autowired
    private TrtcreDiasavRegister trtcreDiasavRegister;
    @Autowired
    private DftcreDiasavRegister dftcreDiasavRegister;

    @Override
    public void diasav(TrndiaVo trndia) {
        trnDiasav(trndia);
        liaallDiasavRegister.diasav(trndia);
        liaallDiasavZZZRegister.diasav(trndia);
        trtcreDiasavRegister.diasav(trndia);
        dftcreDiasavRegister.diasav(trndia);
    }

    private void trnDiasav(TrndiaVo trndiaVo) {
    }
}
